#pragma once

#define TIXML_USE_STL
#include "tinyxml.h"

#include <atlcoll.h>
#include <atlstr.h>
#include <atltypes.h>
#include "AbstractResourceLoader.h"

class NPCOMMONUI_API CNLayoutResourceLoader : public AbstractResourceLoader
{
public:
	CNLayoutResourceLoader();
	virtual ~CNLayoutResourceLoader();

	///< initialize
	BOOL	Init(CNPUnzipFile* zipimage);
	///< uninitialize
	BOOL	Close();

	///< get layout by string id
	BOOL GetLayout(LPCTSTR pszcID, LPRECT pLayout);

	///<  get script xml node
	TiXmlElement* GetPanelNode(LPCTSTR pszcID);

	///
	BOOL GetNodeList(CAtlMap< CString, TiXmlElement* >& lstNode);

private:
	///< parse xml
	BOOL	_ParseXML(const LPBYTE pBuf);
	///< parse item
	BOOL _ParseItemNode(TiXmlElement* pItemNode);
	///< get layout info
	BOOL _GetLayout(TiXmlElement* pItemNode, CString& strID, CRect& rcLayout);
	///< parse scriptlet
	BOOL _ParseScriptletNode(TiXmlElement* pItemNode);

	///< layout map
	CAtlMap< CString, CRect >	m_mapLayout;	
	///< script map
	CAtlMap< CString, TiXmlElement* > m_mapScriptlet;

	CAtlMap< CString, TiXmlElement* > m_mapPadScriptlet;

	CAtlList< TiXmlDocument* > m_lstDocument;
};